;If you write a ";" char left most position the assembler will understand that the line
;is information and should not be assembled!
;
;This program below will make RB0 go high (pin 21) and the LED will start to light.
;The program will lock in a loop and that is all for now!
;
;First I will define some variables to a value.
;This is good because I can then write the lable name instead of the adress number which
;makes it easier to understand and remember.
;
;
;
;
;
STATUS     EQU 3h             ;Define lable STATUS to 3
PORTB      EQU 6h             ;Define lable PORTB  to 6  (Bank 0)
TRISB      EQU 6h             ;Define lable TRISB  to 6  (Bank 1)
;
;TRISB is a register which set the direction of PORTB. It set every pin as input or output. 
;You may wonder how PORTB and TRISB can have same adress 6? THEY DON'T. When bank 0 is set
;you will acces PORTB and when Bank 1 is set you will acces TRISB. Bank selection is made
;in the STATUS register, you will see later in the code.
;
;
;
;================== MAIN PROGRAM ==================================
;
;After a reset the processor will go to adress 000h and start execute. What we want first to 
;happen is that the processor jumps to another adress 010h instead, because at adress 004h you
;will have interupt adress and it would not be good if our program got there, so the common
;procedure is to jump a few adresses ahead.
;
STARTADR:  ORG 000h           ;Point to adress 000h which is the start adress
           GOTO START         ;Jump over the fist adresses and to START
;
           ORG 010h           ;Point to adress 010h. 
START:     MOVLW b'00100000'  ;Load W register so bank 1 will be set (see statusreg in datasheets)
           MOVWF STATUS       ;Move W into STATUS and now Bank 1 will be selected
           MOVLW b'11111110'  ;Load W with data direction for TRISB 1=input 0=output
           MOVWF TRISB        ;Move W into TRISB and RB0 will be an output
           MOVLW b'00000000'  ;Load W register so bank 0 will be set (see statusreg in datasheets)
           MOVWF STATUS       ;Move W into STATUS and now Bank 0 will be selected
;
;What we have done so far is to change bank from 0 to 1 and back to 0,
;and made portB RBO (pin21) to output. The rest of portB are inputs.     
;
           MOVLW b'00000001'  ;Load W with data so the output will go high.
           MOVWF PORTB        ;Move W to port B and now RBO will go high.
;
BACK:      GOTO BACK          ;Make the microcontroller stay in this loop forever.
           END                ;END of program or end of assembling
;
;
;As you can see in this example I first load W with data and then next instruction 
;move the data from W to some register. This is how it works, see instructiontable in the datasheets.
;
;BELOW I HAVE CUT AWAY ALL MY COMMENTS ABOVE AND THIS IS HOW THE SAME CODE WILL LOOK LIKE THEN:
;
;
;
STATUS     EQU 3h             ; 
PORTB      EQU 6h             ; 
TRISB      EQU 6h             ; 
STARTADR:  ORG 000h           ; 
           GOTO START         ; 
           ORG 010h           ; 
START:     MOVLW b'00100000'  ; 
           MOVWF STATUS       ; 
           MOVLW b'11111110'  ; 
           MOVWF TRISB        ; 
           MOVLW b'00000000'  ; 
           MOVWF STATUS       ; 
           MOVLW b'00000001'  ; 
           MOVWF PORTB        ; 
BACK:      GOTO BACK          ; 
           END                ;



